diff --git a/doc/src/sgml/maintenance.sgml b/doc/src/sgml/maintenance.sgml
new file mode 100644
index c34ca53..dc687f9
*** a/doc/src/sgml/maintenance.sgml
--- b/doc/src/sgml/maintenance.sgml
*************** analyze threshold = analyze base thresho
*** 745,752 ****
  
    <para>
     In some situations it is worthwhile to rebuild indexes periodically
!    with the <xref linkend="sql-reindex">
!    command.
    </para>
  
    <para>
--- 745,753 ----
  
    <para>
     In some situations it is worthwhile to rebuild indexes periodically
!    with the <xref linkend="sql-reindex"> command or a series of individual
!    rebuilding steps.
! 
    </para>
  
    <para>
*************** analyze threshold = analyze base thresho
*** 772,777 ****
--- 773,796 ----
     (This consideration does not apply to non-B-tree indexes.)  It
     might be worthwhile to reindex periodically just to improve access speed.
    </para>
+ 
+   <para>
+    <xref linkend="sql-reindex"> can be used safely and easily in all cases.
+    But since the command requires an exclusive table lock, it is
+    often preferable to execute an index rebuild with a sequence of
+    creation and replacement steps.  Index types that support
+    <xref linkend="sql-createindex"> with the <literal>CONCURRENTLY</>
+    option can instead be recreated that way. If that is successful and the
+    resulting index is valid, the original index can then be replaced by
+    the newly built one using combinations of <xref linkend="sql-alterindex">
+    and <xref linkend="sql-dropindex">. When an index is used to enforce
+    uniqueness or other constraints, <xref linkend="sql-altertable"> may
+    also be necessary, to swap the existing constraint to one enforced by
+    the new index. Review this alternate, multiple step rebuild approach
+    very carefully before using it, as there are limitations on which
+    indexes can be reindexed this way, and errors you should detect and
+    handle correctly.
+   </para>
   </sect1>
  
  
diff --git a/doc/src/sgml/ref/create_index.sgml b/doc/src/sgml/ref/create_index.sgml
new file mode 100644
index 01faa3a..9a6a683
*** a/doc/src/sgml/ref/create_index.sgml
--- b/doc/src/sgml/ref/create_index.sgml
*************** CREATE [ UNIQUE ] INDEX [ CONCURRENTLY ]
*** 405,411 ****
     </para>
  
     <para>
!     If a problem arises while scanning the table, such as a
      uniqueness violation in a unique index, the <command>CREATE INDEX</>
      command will fail but leave behind an <quote>invalid</> index. This index
      will be ignored for querying purposes because it might be incomplete;
--- 405,411 ----
     </para>
  
     <para>
!     If a problem arises while scanning the table, such as a deadlock or a
      uniqueness violation in a unique index, the <command>CREATE INDEX</>
      command will fail but leave behind an <quote>invalid</> index. This index
      will be ignored for querying purposes because it might be incomplete;
